package com.fp.persistence.pgeneral.msg;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENEMESSAGESTRUCTUREDATA
 */
@Entity(name = "TgeneMessageStructureData")
@Table(name = "TGENEMESSAGESTRUCTUREDATA")
public class TgeneMessageStructureData extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean,
		Cloneable, Log {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneMessageStructureData
	 */
	@EmbeddedId
	private TgeneMessageStructureDataKey pk;
	@Column(name = "DESCRIPTION", nullable = true)
	/**
	 * Nombre de la columna dentro del archivo
	 */
	private String description;

	@Version
	@Column(name = "RECORDVERSION", nullable = true)
	/**
	 * Optimistic locking del registro
	 */
	private Integer recordversion;

	@Column(name = "DATATYPE", nullable = false)
	/**
	 * Tipo de dato del campo, sirve para verificar si es un numero no se ingrese caracteres.
	 */
	private String datatype;

	@Column(name = "LENGTH", nullable = true)
	/**
	 * Longitud de lectura del campo.
	 */
	private Integer length;

	@Column(name = "REQUIRED", nullable = true)
	/**
	 * Y si el campo es requerido
	 */
	private String required;

	@Column(name = "INITPOSITION", nullable = true)
	/**
	 * Si el campo no maneja separadores, aqui se define la posicion inicial del registro.
	 */
	private Integer initposition;

	@Column(name = "ENDPOSITION", nullable = true)
	/**
	 * Si el campo no maneja separadores, aqui se define la posicion final del registro.
	 */
	private Integer endposition;

	@Column(name = "DECIMALNUMBER", nullable = true)
	/**
	 * Numero de decimales
	 */
	private Integer decimalnumber;

	@Column(name = "INITVALUE", nullable = true)
	/**
	 * Valor por defecto o inicial del campo.
	 */
	private String initvalue;

	@Column(name = "FILLERCHARACTER", nullable = true)
	/**
	 * Caracter de relleno del campo
	 */
	private String fillercharacter;

	@Column(name = "LEFTREFILLER", nullable = true)
	/**
	 * Y indica que el campo se rellena a la izquiera con el caracter de relleno hasta completar la longitud del campo.
	 */
	private String leftrefiller;

	@Column(name = "ATTRIBUTE", nullable = true)
	/**
	 * Nombre del campo asociado a un bean.
	 */
	private String attribute;

	/** Contructor por defecto */
	public TgeneMessageStructureData() {
	}

	/**
	 * Contructor de TgeneMessageStructureData
	 * 
	 * @param pPk Clave Primaria del entity
	 * @param pDatatype Tipo de dato del campo, sirve para verificar si es un
	 *            numero no se ingrese caracteres.
	 */
	public TgeneMessageStructureData(TgeneMessageStructureDataKey pPk, String pDatatype) {
		this();
		pk = pPk;
		datatype = pDatatype;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneMessageStructureData
	 */
	public static TgeneMessageStructureData find(EntityManager pEntityManager, TgeneMessageStructureDataKey pKey)
			throws Exception {
		TgeneMessageStructureData obj = pEntityManager.find(TgeneMessageStructureData.class, pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgeneMessageStructureData
	 * 
	 * @return El objeto que referencia a la Clave primaria de
	 *         TgeneMessageStructureData
	 */
	public TgeneMessageStructureDataKey getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneMessageStructureData
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de
	 *            TgeneMessageStructureData
	 */
	public void setPk(TgeneMessageStructureDataKey pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de description
	 * 
	 * @return valor de description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Fija el valor de description
	 * 
	 * @param pDescription nuevo Valor de description
	 */
	public void setDescription(String pDescription) {
		description = pDescription;
	}

	/**
	 * Obtiene el valor de recordversion
	 * 
	 * @return valor de recordversion
	 */
	public Integer getRecordversion() {
		return recordversion;
	}

	/**
	 * Fija el valor de recordversion
	 * 
	 * @param pRecordversion nuevo Valor de recordversion
	 */
	public void setRecordversion(Integer pRecordversion) {
		recordversion = pRecordversion;
	}

	/**
	 * Obtiene el valor de datatype
	 * 
	 * @return valor de datatype
	 */
	public String getDatatype() {
		return datatype;
	}

	/**
	 * Fija el valor de datatype
	 * 
	 * @param pDatatype nuevo Valor de datatype
	 */
	public void setDatatype(String pDatatype) {
		datatype = pDatatype;
	}

	/**
	 * Obtiene el valor de length
	 * 
	 * @return valor de length
	 */
	public Integer getLength() {
		return length;
	}

	/**
	 * Fija el valor de length
	 * 
	 * @param pLength nuevo Valor de length
	 */
	public void setLength(Integer pLength) {
		length = pLength;
	}

	/**
	 * Obtiene el valor de required
	 * 
	 * @return valor de required
	 */
	public String getRequired() {
		return required;
	}

	/**
	 * Fija el valor de required
	 * 
	 * @param pRequired nuevo Valor de required
	 */
	public void setRequired(String pRequired) {
		required = pRequired;
	}

	/**
	 * Obtiene el valor de initposition
	 * 
	 * @return valor de initposition
	 */
	public Integer getInitposition() {
		return initposition;
	}

	/**
	 * Fija el valor de initposition
	 * 
	 * @param pInitposition nuevo Valor de initposition
	 */
	public void setInitposition(Integer pInitposition) {
		initposition = pInitposition;
	}

	/**
	 * Obtiene el valor de endposition
	 * 
	 * @return valor de endposition
	 */
	public Integer getEndposition() {
		return endposition;
	}

	/**
	 * Fija el valor de endposition
	 * 
	 * @param pEndposition nuevo Valor de endposition
	 */
	public void setEndposition(Integer pEndposition) {
		endposition = pEndposition;
	}

	/**
	 * Obtiene el valor de decimalnumber
	 * 
	 * @return valor de decimalnumber
	 */
	public Integer getDecimalnumber() {
		return decimalnumber;
	}

	/**
	 * Fija el valor de decimalnumber
	 * 
	 * @param pDecimalnumber nuevo Valor de decimalnumber
	 */
	public void setDecimalnumber(Integer pDecimalnumber) {
		decimalnumber = pDecimalnumber;
	}

	/**
	 * Obtiene el valor de initvalue
	 * 
	 * @return valor de initvalue
	 */
	public String getInitvalue() {
		return initvalue;
	}

	/**
	 * Fija el valor de initvalue
	 * 
	 * @param pInitvalue nuevo Valor de initvalue
	 */
	public void setInitvalue(String pInitvalue) {
		initvalue = pInitvalue;
	}

	/**
	 * Obtiene el valor de fillercharacter
	 * 
	 * @return valor de fillercharacter
	 */
	public String getFillercharacter() {
		return fillercharacter;
	}

	/**
	 * Fija el valor de fillercharacter
	 * 
	 * @param pFillercharacter nuevo Valor de fillercharacter
	 */
	public void setFillercharacter(String pFillercharacter) {
		fillercharacter = pFillercharacter;
	}

	/**
	 * Obtiene el valor de leftrefiller
	 * 
	 * @return valor de leftrefiller
	 */
	public String getLeftrefiller() {
		return leftrefiller;
	}

	/**
	 * Fija el valor de leftrefiller
	 * 
	 * @param pLeftrefiller nuevo Valor de leftrefiller
	 */
	public void setLeftrefiller(String pLeftrefiller) {
		leftrefiller = pLeftrefiller;
	}

	/**
	 * Obtiene el valor de attribute
	 * 
	 * @return valor de attribute
	 */
	public String getAttribute() {
		return attribute;
	}

	/**
	 * Fija el valor de attribute
	 * 
	 * @param pAttribute nuevo Valor de attribute
	 */
	public void setAttribute(String pAttribute) {
		attribute = pAttribute;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneMessageStructureData))
			return false;
		TgeneMessageStructureData that = (TgeneMessageStructureData) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad
	 * TgeneMessageStructureData
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/**
	 * Implementación de la creación de un bean en blanco
	 * TgeneMessageStructureData
	 */
	public Object createInstance() {
		TgeneMessageStructureData instance = new TgeneMessageStructureData();
		instance.setPk(new TgeneMessageStructureDataKey());
		return instance;
	}

	/**
	 * Clona la entidad TgeneMessageStructureData
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneMessageStructureData p = (TgeneMessageStructureData) this.clone();
		p.setPk((TgeneMessageStructureDataKey) this.pk.cloneMe());
		return p;
	}
	
	//METODOS MANUALES
    private static final String HQL_WITH_FILTER =
            "from TgeneMessageStructureData tb  "
            + " where tb.pk.structurecode = :structurecode "
            + " order by tb.pk.code ";

    /**
     * Metodo que devuelve una lista de objetos TgeneMessageStructureData
     * @param pEntityManager
     * @param structurecode Codigo de estructura
     * @return  List<TgeneMessageStructure>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
	public static List<TgeneMessageStructureData> find(EntityManager pEntityManager, String structurecode) throws Exception {
        List<TgeneMessageStructureData> lStructure = null;
        Query qry = pEntityManager.createQuery(HQL_WITH_FILTER);
        qry.setParameter("structurecode", structurecode);
        lStructure = qry.getResultList();
        return lStructure;
    }
}
